package com.hzs.common.security.utils;

import javax.servlet.http.HttpServletRequest;

import com.hzs.common.core.constant.MagicNumberConstants;
import com.hzs.common.core.exception.auth.NotPermissionException;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import com.hzs.common.core.constant.SecurityConstants;
import com.hzs.common.core.constant.TokenConstants;
import com.hzs.common.core.context.SecurityContextHolder;
import com.hzs.common.core.utils.ServletUtils;
import com.hzs.common.core.utils.StringUtils;

/**
 * 权限获取工具类
 *
 * @author hzs
 */
public class SecurityUtils {

    /**
     * 前后+后台 获取登录国家
     *
     * @return
     */
    public static Integer getPkCountry() {
        String str = SecurityContextHolder.get(SecurityConstants.DETAILS_USER_COUNTRY);
        if (StringUtils.isNotEmpty(str)) {
            return Integer.parseInt(str);
        }
        throw new NotPermissionException("登录已超时，请重新登录");
    }

    /**
     * 后台管理员获取userName
     */
    public static String getUsername() {
        return SecurityContextHolder.getUserName();
    }

    /**
     * 前台会员获取memberCode（尽量不要直接使用此编号进行业务处理，因为后台可以修改用户编号，用户登录中不会更新）
     */
    public static String getMemberCode() {
        return SecurityContextHolder.getUserName();
    }

    /**
     * 前台获取登录会员类型（来源于ELoginType，主要用于小程序登录未绑定会员时校验使用）
     *
     * @return
     */
    public static String getMemberType() {
        return SecurityContextHolder.getUserType();
    }

    /**
     * 获取用户ID（前台+后台通用）
     */
    public static Long getUserId() {
        return SecurityContextHolder.getUserId();
    }

    /**
     * 获取请求token（前台+后台通用）
     */
    public static String getToken() {
        return getToken(ServletUtils.getRequest());
    }

    /**
     * 根据request获取请求token
     */
    public static String getToken(HttpServletRequest request) {
        // 从header获取token标识
        String token = request.getHeader(TokenConstants.AUTHENTICATION);
        return replaceTokenPrefix(token);
    }

    /**
     * 裁剪token前缀
     */
    public static String replaceTokenPrefix(String token) {
        // 如果前端设置了令牌前缀，则裁剪掉前缀
        if (StringUtils.isNotEmpty(token) && token.startsWith(TokenConstants.PREFIX)) {
            token = token.replaceFirst(TokenConstants.PREFIX, "");
        }
        return token;
    }

    /**
     * 是否为管理员
     *
     * @param userId 用户ID
     * @return 结果
     */
    public static boolean isAdmin(Long userId) {
        return MagicNumberConstants.PK_ADMIN.equals(userId);
    }

    /**
     * 生成BCryptPasswordEncoder密码
     *
     * @param password 密码
     * @return 加密字符串
     */
    public static String encryptPassword(String password) {
        BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        return passwordEncoder.encode(password);
    }

    /**
     * 判断密码是否相同
     *
     * @param rawPassword     真实密码
     * @param encodedPassword 加密后字符
     * @return 结果 true = 密码相同
     */
    public static boolean matchesPassword(String rawPassword, String encodedPassword) {
        BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        return passwordEncoder.matches(rawPassword, encodedPassword);
    }

}
